<?php
defined('_JEXEC') or die;

if(!defined('DS'))
{
    define('DS',DIRECTORY_SEPARATOR);
}
class com_albopretorio_onlineInstallerScript
{

	function createFolderAllegati()
	{
		jimport( 'joomla.filesystem.file' );

		if(!JFolder::exists(JPATH_SITE . "/images/allegati_10")){
			JFolder::create(JPATH_SITE. "/images/allegati_10");
		};

		if(!JFile::exists(JPATH_SITE. "/images/allegati_10/index.html")){
			JFile::copy(JPATH_SITE."/images/index.html",JPATH_SITE. "/images/allegati_10/index.html");
		};
		
		JFile::copy(JPATH_SITE."/components/com_albopretorio_online/language/it-IT/it-IT.com_albopretorio_online.ini",JPATH_SITE. "/language/it-IT/it-IT.com_chronoconnectivity5.ini");

		JFile::copy(JPATH_SITE."/components/com_albopretorio_online/language/it-IT/it-IT.com_albopretorio_online.ini",JPATH_SITE. "/language/it-IT/it-IT.com_chronoforms5.ini");
		
		if(!JFolder::exists(JPATH_SITE . "/components/com_chronoconnectivity5/chronoconnectivity/locales/it_it")){
			JFolder::create(JPATH_SITE. "/components/com_chronoconnectivity5/chronoconnectivity/locales/it_it");
		};

		if(!JFile::exists(JPATH_SITE. "/components/com_chronoconnectivity5/chronoconnectivity/locales/it_it/index.html")){
			JFile::copy(JPATH_SITE."/images/index.html",JPATH_SITE. "/components/com_chronoconnectivity5/chronoconnectivity/locales/it_it/index.html");
		};
		
		JFile::copy(JPATH_SITE."/components/com_albopretorio_online/language/it-IT/lang.php",JPATH_SITE."/components/com_chronoconnectivity5/chronoconnectivity/locales/it_it/lang.php");

	}
	
	function aggiornaTabelle1()
	{
		$db =JFactory::getDBO();
		$query = $db->getQuery(true);
		$campi=$db->getTableColumns('#__chronoforms_atto_30');
		
		// correzione campo ord da DISC e DESC
		$query = $db->getQuery(true);		
		$query = "UPDATE `#__chronoforms_configurazi_30` SET `ord` = 'DESC' WHERE `#__chronoforms_configurazi_30`.`ord` = 'DISC'"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_configurazi_30 corretto campo ord').'</p>';
		}

		// correzione campo cod_ente
		$query = $db->getQuery(true);		
		$query = "UPDATE `#__chronoforms_atto_30` SET `cod_ente` = '1' WHERE `#__chronoforms_atto_30`.`cod_ente` = '0'"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_atto_30 corretto campo cod_ente').'</p>';
		}
		
		if (!isset($campi['atto_status'])) {
		// crea nuovi campi nella tabella #_chronoforms_atto_30	
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_atto_30` CHANGE `atto_cf_id` `atto_status` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "Originale"'; 
		$db->setQuery($query);		
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_atto_30 modificato campo atto_status').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_configurazi_30` CHANGE `elenco_cat` `data_oggi` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_configurazi_30 creato campo data_oggi').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_e_30` ADD `modified` DATETIME NOT NULL AFTER `recordtime`'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_e_30 creato campo modified').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_e_30` CHANGE `recordtime` `created` DATETIME NOT NULL'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_e_30 modificato campo created').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_e_30` CHANGE `cf_user_id` `user_id` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_e_30 modificato campo user_id').'</p>';
		}

		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_sezione_30` ADD `modified` DATETIME NOT NULL AFTER `created`'; 
		$db->setQuery($query);
		if ($db->execute()) { 
		echo '<p>' . JText::_('Tabella #__chronoforms_sezione_30 creato campo modified').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_categoria_30` ADD `modified` DATETIME NOT NULL AFTER `created`'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_categoria_30 creato campo modified').'</p>';
		}

		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_ute_30` ADD `modified` DATETIME NOT NULL AFTER `created`'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_ute_30 creato campo modified').'</p>';
		}
		
		$query = $db->getQuery(true);	
		$query = 'ALTER TABLE `#__chronoforms_ute_30` CHANGE `created` `created` DATETIME NOT NULL'; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_ute_30 modificato campo created').'</p>';
		}		
		
		echo '<p>' . JText::_('Tabelle aggiornate alla versione')." ".JText::_('COM_ALBOPRETORIO_ONLINE_POST_VERSION').'</p>';
		}
		
		if (!isset($campi['cod_macro'])) {
		// crea nuovi campi nella tabella #__chronoforms_atto_30
		$query = $db->getQuery(true);	
		$query = "ALTER TABLE `#__chronoforms_atto_30` ADD `cod_macro` INT(3) NOT NULL DEFAULT '0' AFTER `cod_ente`"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_atto_30 creato campo cod_macro').'</p>';
		}
		
		// crea nuovi campi nella tabella #__chronoforms_atto_30
		$query = $db->getQuery(true);	
		$query = "ALTER TABLE `#__chronoforms_atto_30` ADD `cod_tipo` INT(3) NOT NULL DEFAULT '0' AFTER `cod_macro`"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_atto_30 creato campo cod_tipo').'</p>';
		}
		}
		
		$query = $db->getQuery(true);
		$campi=$db->getTableColumns('#__chronoforms_configurazi_30');
		
		if (!isset($campi['amm_tra'])) {
		// crea nuovi campi nella tabella #__chronoforms_configurazi_30
		$query = $db->getQuery(true);	
		$query = "ALTER TABLE `#__chronoforms_configurazi_30` ADD `amm_tra` INT(1) NOT NULL DEFAULT '0' AFTER `max_allegati`"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_configurazi_30 creato campo amm_tra').'</p>';
		}
		
		// crea nuovi campi nella tabella #__chronoforms_configurazi_30
		$query = $db->getQuery(true);	
		$query = "ALTER TABLE `#__chronoforms_configurazi_30` ADD `at_pag` VARCHAR(400) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL AFTER `amm_tra`"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_configurazi_30 creato campo at_pag').'</p>';
		}
		}
		
		if (!isset($campi['firma'])) {
		// crea nuovi campi nella tabella #__chronoforms_configurazi_30
		$query = $db->getQuery(true);	
		$query = "ALTER TABLE `#__chronoforms_configurazi_30` ADD `firma` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL AFTER `at_pag`;"; 
		$db->setQuery($query);
		if ($db->execute()) {
		echo '<p>' . JText::_('Tabella #__chronoforms_configurazi_30 creato campo firma').'</p>';
		}
		}
		
	}

	function install($parent)
	{
		$this->createFolderAllegati();
		//$parent->getParent()->setRedirectURL('index.php?option=com_albopretorio_online');
		
		// salva i valori in extras
		//leggere i valori della configurazione o installa quelli predefiniti.
		$db =JFactory::getDBO();
		$db_prefix = $db->getPrefix();
		$diff= strlen('mla1m_')-strlen($db_prefix);
		$query = $db->getQuery(true);
		$query->select(array('*'));
		$query->from($db->quoteName('#__chronoforms_configurazi_30'));
		$db->setQuery($query);
		$db->execute();
		if ($db->getNumRows()<1) {
		$query = $db->getQuery(true);
		// Insert columns.
		$columns = array('created', 'modified', 'user_id', 'email', 'ente', 'dir_allegati', 'link_allegati', 'copy_file', 'elenco_sez', 'data_oggi', 'confnumero_albo', 'confanno_albo', 'confnumero_atto', 'confdata_atto', 'conftitolo_atto', 'confente_atto', 'confdate_atto', 'confsezione_atto', 'confcategoria_atto', 'offset', 'pubb', 'ord', 'prot', 'lightbox', 'css_elenchi', 'allegati', 'max_allegati', 'amm_tra', 'at_pag', 'firma');
		// Insert values.
		$values = array($db->quote('2015-02-02 05:00:00'), $db->quote('2015-02-02 17:00:00'), $db->quote(''), $db->quote(''), $db->quote('NO'), $db->quote('SI'), $db->quote('SI'), $db->quote('NO'), $db->quote('NO'), $db->quote('NO'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), $db->quote('SI'), 0, $db->quote('SI'), $db->quote('DESC'), $db->quote('NO'), $db->quote('SI'), 3, $db->quote('bmp-jpg-png-pdf-doc-docx-xls-xlsx-ods-odt-p7m-rtf-xml'), 1000, 0, $db->quote(''), $db->quote(''));
		// Prepare the insert query.
		$query
		->insert($db->quoteName('#__chronoforms_configurazi_30'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();
		}
		$query = $db->getQuery(true);
		$query->select(array('*'));
		$query->from($db->quoteName('#__chronoforms_configurazi_30'));
		$query->where($db->quoteName('id')." = ".$db->quote('1'));
		$db->setQuery($query);
		$conf = $db->loadObject();

		// selezione della directory
		$upload_path = JPATH_SITE.DS.'images'.DS.'allegati_10'.DS;
		//impostazione estensioni  bmp-jpg-png-pdf-doc-docx-xls-xlsx-ods-odt-p7m-rtf";
		$files="allegato:".$conf->allegati;
		//impostazione max dimensione
		$max_size=$conf->max_allegati;
		// trova nome ente titolare albo
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('nome_ente')));
		$query->from($db->quoteName('#__chronoforms_e_30'));
		$query->where($db->quoteName('cf_id') . ' = '.$db->quote('1'));
		$db->setQuery($query);
		$ente = $db->loadResult();
    
		//inserimento parametri uploads in form atto_10, allegati_modifiche,allegati_aggiungi
		$nomes =array('atto_10','allegati_modifiche','allegati_aggiungi','export_in_pdf');
		foreach ($nomes as $nome) 
		{
		$query = $db->getQuery(true);
		$query
		->select($db->quoteName('extras'))
		->from($db->quoteName('#__chronoengine_chronoforms'))
		->where($db->quoteName('title')." = ".$db->quote($nome));
    
		$db->setQuery($query);
		$extras= $db->loadResult();
		$extras0=unserialize(base64_decode(trim($extras)));
		if ($nome=='atto_10')
		{
		$extras0['actions_config']['60']['upload_path'] = $upload_path;
		$extras0['actions_config']['60']['files'] = $files;
		$extras0['actions_config']['60']['max_size'] = $max_size;
		}
		if ($nome== 'allegati_modifiche' or $nome == 'allegati_aggiungi')
		{
		$extras0['actions_config']['78']['upload_path'] = $upload_path;
		$extras0['actions_config']['78']['files'] = $files;
		$extras0['actions_config']['78']['max_size'] = $max_size;
		}
		if ($nome == 'export_in_pdf')
		{
		$extras0['actions_config']['11']['pdf_title'] = $ente.' - Albo Pretorio On Line REGISTRO ATTI PUBBLICATI';
		}
		
		$alfa=base64_encode(serialize($extras0));
    
		// Fields to update.
		$query = $db->getQuery(true);
		$fields = array(
		$db->quoteName('extras') . ' = ' . $db->quote($alfa)
		);
    	// Conditions for which records should be updated.
		$conditions = array(
        $db->quoteName('title') . ' = ' . $db->quote($nome)
		);
		$query->update($db->quoteName('#__chronoengine_chronoforms'))->set($fields)->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();
		}
	
		$tables = array('chronoforms_atto_30','chronoforms_allegati_30','chronoforms_categoria_30','chronoforms_sezione_30','chronoforms_ute_30','chronoforms_configurazi_30','chronoforms_e_30');
		
		if ($db_prefix <>'mla1m_') {		
		//inserimento prefisso db in 23 form 
		$nomes =array('finestra_avvio','inserimento_sezioni','modifica_sezioni','inserimento_categorie','modifica_categorie','modifica_utenti','atto_10','allegati_aggiungi','allegati_modifiche','atti_modifiche','atti_vista','atti_aggiorna','configurazione_albo','utenti_albo','utenti_non_autorizzati','inserimento_enti','modifica_enti','migrazione_da_albo_J15','export','pulizia_archivi','migrazione_da_albo_Joomla_25x_3x','export_in_pdf','atti_certifica');
		foreach ($nomes as $nome) 
		{
		$query = $db->getQuery(true);
		$query
		->select($db->quoteName('extras'))
		->from($db->quoteName('#__chronoengine_chronoforms'))
		->where($db->quoteName('title')." = ".$db->quote($nome));
    
		$db->setQuery($query);
		$extras= $db->loadResult();

		$extras0=base64_decode(trim($extras));

		while (substr_count($extras0,'mla1m_')) {
			$str1=explode(':"mla1m_',$extras0,2);
			$lng=substr(strrchr($str1[0], ":"), 1);
			//$lng=substr($str1[0],-2);
			$lngo= intval($lng);
			$lngn=$lngo-$diff;
			$lngs=strval($lngn);
			$extras0=substr($str1[0],0,(-1)*strlen($lng)).$lngs.':"'.$db_prefix.$str1[1];
		}
		
		$alfa=base64_encode($extras0);
		
		// Fields to update.
		$query = $db->getQuery(true);
		$fields = array(
		$db->quoteName('extras') . ' = ' . $db->quote($alfa)
		);
    	// Conditions for which records should be updated.
		$conditions = array(
        $db->quoteName('title') . ' = ' . $db->quote($nome)
		);
		$query->update($db->quoteName('#__chronoengine_chronoforms'))->set($fields)->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();
		}

		
		//inserimento prefisso db in 15 connectivity 
		$nomes =array('albo_tutti','modifica_sezioni','modifica_categorie','atti_modifiche','atti_aggiorna','albo_pretorio','albo_atti_accessibili','modifica_enti','albo_ricerca','albo_storico_ricerca','albo_pretorio_ricerca','elenchi_utenti','albo_log','albo_atti_sezioni_categorie','sezioni_categorie','albo_at_macrofamiglie_tipologie','at_macrofamiglie_tipologie');
		foreach ($nomes as $nome) 
		{
		$query = $db->getQuery(true);
		$query
		->select($db->quoteName('extras'))
		->from($db->quoteName('#__chronoengine_connections'))
		->where($db->quoteName('title')." = ".$db->quote($nome));
    
		$db->setQuery($query);
		$extras= $db->loadResult();
		$extras0=base64_decode(trim($extras));	
		
		while (substr_count($extras0,'mla1m_')) {
			$str1=explode(':"mla1m_',$extras0,2);
			$lng=substr(strrchr($str1[0], ":"), 1);
			//$lng=substr($str1[0],-2);
			$lngo= intval($lng);
			$lngn=$lngo-$diff;
			$lngs=strval($lngn);
			$extras0=substr($str1[0],0,(-1)*strlen($lng)).$lngs.':"'.$db_prefix.$str1[1];
		}
		$extras=base64_encode($extras0);
		
		$extras2=unserialize(base64_decode(trim($extras)));
		
		for ($i = 1; $i < 10; $i++) {
		$extras2['front']['permissions']['index'][$i]= 1;
		}
		$alfa=base64_encode(serialize($extras2));
    
		// Fields to update.
		$query = $db->getQuery(true);
		$fields = array(
		$db->quoteName('extras') . ' = ' . $db->quote($alfa)
		);
    	// Conditions for which records should be updated.
		$conditions = array(
        $db->quoteName('title') . ' = ' . $db->quote($nome)
		);
		$query->update($db->quoteName('#__chronoengine_connections'))->set($fields)->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();
		}
		}
		echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_INSTALL_TEXT')." ".JText::_('COM_ALBOPRETORIO_ONLINE_POST_VERSION'). '</p>';
	}

	function uninstall($parent)
	{
	// delete 17 records chronoconnectivity
	$db = JFactory::getDbo();
	
	$connects=array('albo_tutti','modifica_sezioni','modifica_categorie','atti_modifiche','atti_aggiorna','albo_pretorio','albo_atti_accessibili','modifica_enti','albo_ricerca','albo_storico_ricerca','albo_pretorio_ricerca','elenchi_utenti','albo_log','albo_atti_sezioni_categorie','sezioni_categorie','albo_at_macrofamiglie_tipologie','at_macrofamiglie_tipologie');

	foreach ($connects as $connect) {

	$query = $db->getQuery(true);
 	$conditions = array(
    $db->quoteName('title') . ' = ' . $db->quote($connect)
	);
	$query->delete($db->quoteName('#__chronoengine_connections'));
	$query->where($conditions);
	$db->setQuery($query); 
	$result = $db->execute();

	}

	// delete 23 records chronoforms

	$forms=array('finestra_avvio','inserimento_sezioni','modifica_sezioni','inserimento_categorie','modifica_categorie','modifica_utenti','atto_10','allegati_aggiungi','allegati_modifiche','atti_modifiche','atti_vista','atti_aggiorna','configurazione_albo','utenti_albo','utenti_non_autorizzati','inserimento_enti','modifica_enti','migrazione_da_albo_J15','export','pulizia_archivi','migrazione_da_albo_Joomla_25x_3x','export_in_pdf','atti_certifica');

	foreach ($forms as $form) {

	$query = $db->getQuery(true);
 	$conditions = array(
    $db->quoteName('title') . ' = ' . $db->quote($form)
	);
	$query->delete($db->quoteName('#__chronoengine_chronoforms'));
	$query->where($conditions);
	$db->setQuery($query); 
	$result = $db->execute();

	}
	
		echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_UNINSTALL_TEXT') . '</p>';
	}
	
	function update($parent)
	{
		$this->createFolderAllegati();
		$this->install($parent);
		$this->aggiornaTabelle1();	
		
		echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_UPDATE_TEXT')." ".JText::_('COM_ALBOPRETORIO_ONLINE_POST_VERSION') . '</p>';
	}

	function preflight($type, $parent)
	{
		//echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_PREFLIGHT_' . $type . '_TEXT') . '</p>';
		echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_PREFLIGHT_TEXT') . '</p>';
	}

	function postflight($type, $parent)
	{
		$this->aggiornaTabelle1();		
		//echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_POSTFLIGHT_' . $type . '_TEXT') . '</p>';
		echo '<p>' . JText::_('COM_ALBOPRETORIO_ONLINE_POSTFLIGHT_TEXT') . '</p>';
	}
}